﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：Element.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 22:28
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System;

namespace ReplacementTemplateEngine
{
	/// <summary>
	/// 表示模板基本元素。
	/// </summary>
	public abstract class Element
	{
		/// <summary>
		/// 初始化 <see cref="Element"/> 类的新实例。
		/// </summary>
		/// <param name="line">行数。</param>
		/// <param name="column">列数。</param>
		protected Element(int line, int column)
		{
			if (line < 1) throw new ArgumentOutOfRangeException("line");
			if (column < 1) throw new ArgumentOutOfRangeException("column");

			this.Line = line;
			this.Column = column;
		}

		/// <summary>
		/// 获取模板元标签所在位置的列数。
		/// </summary>
		public int Column { get; private set; }

		/// <summary>
		/// 获取模板元标签所在位置的行数。
		/// </summary>
		public int Line { get; private set; }
	}
}
