﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：ITemplateEngine.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-04 12:00
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System.IO;

namespace ReplacementTemplateEngine
{
	/// <summary>
	/// 定义模板引擎的基本功能。
	/// </summary>
	public interface ITemplateEngine
	{
		/// <summary>
		/// 获取模板。
		/// </summary>
		Template Template { get; }

		/// <summary>
		/// 设定变量标记的置换值。
		/// </summary>
		/// <param name="key">键名。</param>
		/// <param name="value">值。</param>
		void SetVariable(string key, object value);

		/// <summary>
		/// 删除变量标记的置换值。
		/// </summary>
		/// <param name="key">键名。</param>
		void RemoveVariable(string key);

		/// <summary>
		/// 清空变量标记的置换值。
		/// </summary>
		void ClearVariables();

		/// <summary>
		/// 处理模板。将处理结果保存到字符编写器中。
		/// </summary>
		/// <param name="writer">指定一个字符编写器。</param>
		void Process(TextWriter writer);

		/// <summary>
		/// 处理模板。并将结果作为字符串返回。
		/// </summary>
		/// <returns>返回 <see cref="System.String"/>。</returns>
		string Process();
	}
}
