﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：TokenKind.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-04 12:35
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

namespace ReplacementTemplateEngine.Parser
{
	/// <summary>
	/// 表示 Token 类型的枚举值。
	/// </summary>
	internal enum TokenKind
	{
		/// <summary>
		/// 未指定类型。
		/// </summary>
		None = 0,

		/// <summary>
		/// 左大括号。
		/// </summary>
		LeftBracket = 1,

		/// <summary>
		/// 右大括号。
		/// </summary>
		RightBracket = 2,

		/// <summary>
		/// 普通文本。
		/// </summary>
		Text = 3,

		/// <summary>
		/// 标签。
		/// </summary>
		Label = 4,

		/// <summary>
		/// 格式化字符串前导符号。
		/// </summary>
		FormatStringPreamble = 5,

		/// <summary>
		/// 格式化字符串。
		/// </summary>
		FormatString = 6,

		/// <summary>
		/// 表示字符流末尾。
		/// </summary>
		EOF = 7
	}
}
