﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：TextElement.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 22:38
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System;

namespace ReplacementTemplateEngine
{
	/// <summary>
	/// 表示文本元素。
	/// </summary>
	public sealed class TextElement : Element
	{
		/// <summary>
		/// 初始化 <see cref="TextElement"/> 类的新实例。
		/// </summary>
		/// <param name="line">行数。</param>
		/// <param name="column">列数。</param>
		/// <param name="text">文本内容。</param>
		public TextElement(int line, int column, string text) : base(line, column)
		{
			if (text == null) throw new ArgumentNullException("text");
			if (text.Length == 0) throw new ArgumentOutOfRangeException("text");

			this.Text = text;
		}

		/// <summary>
		/// 获取文本内容。
		/// </summary>
		public string Text { get; private set; }
	}
}
