﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：VariableLabel.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 22:38
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System;
using System.Collections.Generic;

namespace ReplacementTemplateEngine
{
	/// <summary>
	/// 表示变量标签。
	/// </summary>
	public class VariableLabel : Element
	{
		/// <summary>
		/// 初始化 <see cref="VariableLabel"/> 的新实例。
		/// </summary>
		/// <param name="line">行数。</param>
		/// <param name="column">列数。</param>
		/// <param name="name">变量标记的名称。</param>
		public VariableLabel(int line, int column, string name) : base(line, column)
		{
			if (name == null) throw new ArgumentNullException("name");
			if (name.Length == 0) throw new ArgumentOutOfRangeException("name");

			this.Name = name;
		}

		/// <summary>
		/// 获取变量标记的名称。
		/// </summary>
		public string Name { get; private set; }

		/// <summary>
		/// 处置当前元素。
		/// </summary>
		/// <param name="variables">与当前元素关联的对象。</param>
		/// <returns>返回 <see cref="System.String"/>。</returns>
		public virtual string Process(Dictionary<string, object> variables)
		{
			if (variables == null || variables.Count == 0) return String.Empty;
			if (variables.ContainsKey(this.Name) == false) return String.Empty;

			var value = variables[this.Name];

			return value.ToString();
		}
	}
}
