﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：NormalUnitTests.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 16:01
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System.Diagnostics;
using System.Text;
using NUnit.Framework;
using Omega.Alpha.Common;

namespace ReplacementTemplateEngine.bak1
{
	/// <summary>
	/// 为了制作简便，我使用单元测试来模拟实战代码，但这里并不是真正合法的单元测试，望谅解！
	/// </summary>
	[TestFixture]
	public class NormalUnitTests
	{
		/// <summary>
		/// FastReplacer实现。
		/// </summary>
		[Test]
		public void FastReplacer()
		{
			var html = new StringBuilder();

			foreach (var newsItem in TestObjects.NewsItems)
			{
				// 您可以通过修改源代码为FastReplacer增加一个Clear方法
				// 避免产生多个实例以提高性能
				var fs = new FastReplacer("{", "}");
				fs.Append(TestObjects.TEMPLATE_STRING);

				fs.Replace("{url}", newsItem.Key);
				fs.Replace("{title}", newsItem.Value);

				html.AppendLine(fs.ToString());
			}

			Trace.WriteLine(html.ToString());
		}

		/// <summary>
		/// 正则表达式实现。
		/// </summary>
		[Test]
		public void RegexReplace()
		{
			// 省略
		}

		/// <summary>
		/// 最简单的模板引擎。
		/// </summary>
		[Test]
		public void StringReplace()
		{
			var html = new StringBuilder();

			foreach (var newsItem in TestObjects.NewsItems)
			{
				// 查找替换
				var news = TestObjects.TEMPLATE_STRING.Replace("{url}", newsItem.Key).Replace("{title}", newsItem.Value);

				html.AppendLine(news);
			}

			Trace.WriteLine(html.ToString());
		}
	}
}
