﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：TemplateEngineUnitTests.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 20:58
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

using System;
using System.Diagnostics;
using NUnit.Framework;

namespace ReplacementTemplateEngine.bak2
{
	[TestFixture]
	public sealed class TemplateEngineUnitTests
	{
		private const string _templateString = "[<time>{CreationTime:yyyy年MM月dd日 HH:mm:ss}</time>]\r\n<a href=\"{url}\">{title}</a>";
		private const string _html = "[<time>2012年04月03日 16:30:24</time>]\r\n<a href=\"http://www.ymind.net/\">陈彦铭的博客</a>";

		[Test]
		public void ProcessTest()
		{
			var templateEngine = new TemplateEngine();
			templateEngine.Parser(_templateString);
			templateEngine.SetValue("url", "http://www.ymind.net/");
			templateEngine.SetValue("title", "陈彦铭的博客");
			templateEngine.SetValue("CreationTime", new DateTime(2012, 4, 3, 16, 30, 24));

			var html = templateEngine.Process();

			Trace.WriteLine(html);

			Assert.AreEqual(_html, html);
		}

		[Test]
		public void TokensTest()
		{
			var templateEngine = new TemplateEngine();
			templateEngine.Parser(_templateString);

			foreach (var token in templateEngine.Tokens)
			{
				var text = String.Format("[{0}, {1}] {2} {3}", token.Line.ToString("D3"), token.Column.ToString("D3"), token.Kind.ToString().PadLeft(10, ' '), token.Text.Replace("\r\n", "\\r\\n"));

				Trace.WriteLine(text);
			}
		}
	}
}
