﻿// ===============================================================================
//  解决方案：置换型模板引擎
//  项目名称：ReplacementTemplateEngine
//  文件名称：Token.cs
//  代码作者：网鸟老兵团(Me.YMind)
//  创建时间：2012-04-03 20:58
// ===============================================================================
//  Copyright © Htmlbird.Net. All rights reserved .
//  官方网站：http://www.htmlbird.net/
//  技术论坛：http://bbs.htmlbird.net/
//  版权所有：网鸟IT技术论坛 彦铭工作室
// ===============================================================================

namespace ReplacementTemplateEngine.bak2
{
	/// <summary>
	/// 表示一个 Token。
	/// </summary>
	public sealed class Token
	{
		/// <summary>
		/// 初始化 <see cref="Token"/> 对象。
		/// </summary>
		/// <param name="kind"><see cref="TokenKind"/> 的枚举值之一。</param>
		/// <param name="text">Token 文本。</param>
		/// <param name="line">Token 所在的行。</param>
		/// <param name="column">Token 所在的列。</param>
		public Token(TokenKind kind, string text, int line, int column)
		{
			this.Text = text;
			this.Kind = kind;
			this.Column = column;
			this.Line = line;
		}

		/// <summary>
		/// 获取 Token 所在的列。
		/// </summary>
		public int Column { get; private set; }

		/// <summary>
		/// 获取 Token 所在的行。
		/// </summary>
		public int Line { get; private set; }

		/// <summary>
		/// 获取 Token 类型。
		/// </summary>
		public TokenKind Kind { get; private set; }

		/// <summary>
		/// 获取 Token 文本。
		/// </summary>
		public string Text { get; private set; }
	}
}
